PImage img;
PImage sortedImg;
boolean sorted = false; 
import java.util.Arrays;

void setup() {
  size(671, 1000);
  sortedImg = createImage(width, height, RGB);
  img = loadImage("mona.jpg");  // Replace with the path to your image file
  //sortPixelsByValue();
  sortPixelsByValue(); 
}

void sortPixelsByValue() {
  
  img.loadPixels();
  sortedImg.loadPixels();
  
  
  // Create arrays to store the color values of each pixel
  int[] redColors = new int[img.pixels.length];
  int[] blueColors = new int[img.pixels.length];
  int[] greenColors = new int[img.pixels.length];
  
  // Get the brightness value for each pixel
  for (int i = 0; i < img.pixels.length; i++) {
    color pixelColor = img.pixels[i];
    redColors[i] = int(red(pixelColor)); 
    greenColors[i] = int(green(pixelColor)); 
    blueColors[i] = int(blue(pixelColor));
  }
  //sort the arrays

    Arrays.sort(redColors);
    Arrays.sort(greenColors);
    Arrays.sort(blueColors); 

 
  for (int k = 0; k < sortedImg.pixels.length; k++) {
    int sortedColor = color(redColors[k], greenColors[k], blueColors[k]);
    //reverse order
    sortedImg.pixels[sortedImg.pixels.length-k-1] = sortedColor;
  }
  sortedImg.updatePixels();
}

void draw() {
  background(0);
  if (sorted) {
    image(sortedImg, 0, 0);
  } else {
    image(img, 0, 0);
  }
}
void keyPressed() {
  if (key == 's' || key == 'S') {
    sorted = !sorted;
  }
}
